package com.logicbig.example;

import org.springframework.stereotype.Repository;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

@Repository
public class PersonDaoJpaImpl implements Dao<Person> {

    @PersistenceContext
    private EntityManager em;

    @Override
    public void save(Person person) {
        em.persist(person);
    }

    @Override
    public Person load(long id) {
        Person person = em.find(Person.class, id);
        return person;
    }

    @Override
    public void delete(long id) {
        Person employee = em.find(Person.class, id);
        em.remove(employee);
    }

    @Override
    public void update(Person person) {
        em.merge(person);
    }

    @Override
    public List<Person> loadAll() {
        List<Person> persons = em.createQuery("Select t from Person t")
                                 .getResultList();
        return persons;
    }
}